PUBLIC loRegExp,lcText,loX
loRegExp = CREATEOBJECT('VBScript.RegExp')
loRegExp.IgnoreCase = .T.
loRegExp.GLOBAL     = .T.
loRegExp.MultiLine  = .T.


DO reform_ab_source
*DEBUG
*SUSPEND
_CLIPTEXT = reform_block_see(_CLIPTEXT)

PROCEDURE reform_ab_source
PARAMETERS tcdbf
*Get PDM SOurce
 IF EMPTY(tcDBF) THEN
  IF PEMSTATUS(_SCREEN,'gcDiampSource',5) THEN
   lcFile = _SCREEN.gcDiampSource
  ELSE &&PEMSTATUS(_SCREEN ...
   lcFile = ''
  ENDIF &&PEMSTATUS(_SCREEN ...
  IF !EMPTY(lcFile) AND MESSAGEBOX('Open DIA(M)P source '+lcFile+'?',4+32,'DIA(M)P source')=7 THEN
   lcFile = ''
  ENDIF &&!EMPTY(lcFile)   ...
 ELSE &&EMPTY(tcDBF)
  lcFile = tcDBF
 ENDIF &&EMPTY(tcDBF)
 IF EMPTY(lcFile) THEN
  lcFile = GETFILE('DBF','','',0,'PDM DIA(M)P source')
 ENDIF &&EMPTY(lcFile)
 IF EMPTY(lcFile) THEN
  USE IN _PDM_VCX
  RETURN .F.
 ENDIF &&EMPTY(lcFile)

 IF USED('_PDM_Source') THEN
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN _PDM_Source
 ELSE &&USED('_PDM_Source')
  USE (lcFile) ALIAS _PDM_Source EXCLUSIVE IN 0
 ENDIF &&USED('_PDM_Source')

 SELECT _PDM_Source
 IF TYPE('_PDM_Source.HTML')#'M' THEN
  USE
  EXIT
 ENDIF &&TYPE('_PDM_Source.HTML')#'M'

 _SCREEN.ADDPROPERTY('gcDiampSource',lcFile)
 REPLACE html WITH reform_block(html) all
 use
ENDPROC &&reform_ab_source

PROCEDURE reform_block
 PARAMETERS;
  tcText

 tcText = reform_block_see(tcText)
 tcText = reform_block_seealso(tcText)

 RETURN tcText
ENDPROC &&reform_block

PROCEDURE reform_block_see
 PARAMETERS;
  tcText

 lcTag = "see"
 loRegExp.PATTERN = "<\s*("+lcTag+")\s*>(([\s\S](?!<\s*\/\1\s*>))*[\s\S])?<\s*\/\1\s*>"
 loX = loRegExp.execute(tcText)

 lcReturn      = ''
 lnStart       = 1
 IF  loX.COUNT=0 THEN
*we have no see or we will  the whole string
  lnStopp = LEN(tcText)
 ELSE  && lox.count
*to the begin of first occurence of "see"
  lnStopp = loX.ITEM(0).FirstIndex
 ENDIF  && lox.count

 FOR lnloop1 = 0 TO loX.COUNT
  lcReturn = lcReturn+SUBSTR(tcText,lnStart,lnStopp)
  DO CASE
   CASE lnloop1<loX.COUNT-1
* those are all parts between Start of tcText and the last pattern
* so the next part is between end of this pattern and begin of the next one
    lcTagText = loX.ITEM(lnloop1).VALUE
    lnStart   = loX.ITEM(lnloop1).FirstIndex+loX.ITEM(lnloop1).LENGTH+1
    lnStopp   = loX.ITEM(lnloop1+1).FirstIndex-lnStart
   CASE lnloop1<loX.COUNT
* this is the last pattern
* so the next part is between end of this pattern and end of tcText
    lcTagText = loX.ITEM(lnloop1).VALUE
    lnStart   = loX.ITEM(lnloop1).FirstIndex+loX.ITEM(lnloop1).LENGTH+1
    lnStopp   = LEN(tcText)-lnStart
   OTHERWISE
    EXIT
  ENDCASE
  loRegExp.PATTERN = "<\s*\/?("+lcTag+")\s*>"
  lcTagText        = loRegExp.REPLACE(lcTagText,'')
  lcReturn = lcReturn+[<see]+reformat_Link(lcTagText)+[see>]
 ENDFOR &&lnloop
 RETURN lcReturn
ENDPROC &&reform_block_see

PROCEDURE reform_block_seealso
 PARAMETERS;
  tcText

 lcTag = "seealso"
 loRegExp.PATTERN = "<\s*("+lcTag+")\s*>(([\s\S](?!<\s*\/\1\s*>))*[\s\S])?<\s*\/\1\s*>"
 loX = loRegExp.execute(tcText)

 lcReturn      = ''
 lcsee         = ''
 lnStart       = 1
 IF  loX.COUNT=0 THEN
*we have no see or we will  the whole string
  lnStopp = LEN(tcText)
 ELSE  && lox.count
*to the begin of first occurence of "see"
  lnStopp = loX.ITEM(0).FirstIndex
 ENDIF  && lox.count

 FOR lnloop1 = 0 TO loX.COUNT
  lcReturn = lcReturn+SUBSTR(tcText,lnStart,lnStopp)
  DO CASE
   CASE lnloop1<loX.COUNT-1
* those are all parts between Start of tcText and the last pattern
* so the next part is between end of this pattern and begin of the next one
    lcTagText = loX.ITEM(lnloop1).VALUE
    lnStart   = loX.ITEM(lnloop1).FirstIndex+loX.ITEM(lnloop1).LENGTH+1
    lnStopp   = loX.ITEM(lnloop1+1).FirstIndex-lnStart
   CASE lnloop1<loX.COUNT
* this is the last pattern
* so the next part is between end of this pattern and end of tcText
    lcTagText = loX.ITEM(lnloop1).VALUE
    lnStart   = loX.ITEM(lnloop1).FirstIndex+loX.ITEM(lnloop1).LENGTH+1
    lnStopp   = LEN(tcText)-lnStart
   OTHERWISE
    EXIT
  ENDCASE
  loRegExp.PATTERN = "<\s*\/?("+lcTag+")\s*>"
  lcTagText        = loRegExp.REPLACE(lcTagText,'')
IF !EMPTY(lcTagText) THEN
  lcsee = lcsee+CHR(13)+CHR(10)+[ <see]+reformat_Link(lcTagText)+[see>]
ENDIF &&!EMPTY(lcTagText) 
 ENDFOR &&lnloop
IF !EMPTY(lcsee) THEN
 RETURN lcReturn+CHR(13)+CHR(10)+"<seealso>"+lcsee+CHR(13)+CHR(10)+"</seealso>"
ELSE &&!EMPTY(lcsee)
 RETURN tcText
ENDIF &&!EMPTY(lcsee) 
ENDPROC &&reform_block_seealso

PROCEDURE reformat_Link
 PARAMETERS;
  tcText

 DO CASE
  CASE OCCURS(':',tcText)<2
*  not enough delimiters, no link defined, display as error
   RETURN [<see>]+tcText+[</see>]
  OTHERWISE
*  special problems:
*   TargetLoc may hold spaces
*   not each part must be filled
   lnTemp1       = 1
   lnTemp2       = AT(':',tcText,1)
   lcTargetLoc   = SUBSTR(tcText,lnTemp1,lnTemp2-lnTemp1)
   lnTemp1       = lnTemp2+1
   lnTemp2       = AT(':',tcText,2)
   lcTargetClass = SUBSTR(tcText,lnTemp1,lnTemp2-lnTemp1)
   tcText        = SUBSTR(tcText,lnTemp2+1)
   lnTemp1       = 1
   lnTemp2       = AT(' ',tcText)
   lcTargetPEM   = SUBSTR(tcText,lnTemp1,lnTemp2-lnTemp1)
   tcText        = SUBSTR(tcText,lnTemp2+1)
 ENDCASE
 RETURN [ loca="]+lcTargetLoc+[" class="]+lcTargetClass+[" member="]+lcTargetPEM+[">]+tcText+[</]
ENDPROC &&reformat_Link
